package DX::Action::BindValue;

use DX::Update::SetValue;
use DX::ActionBuilder::BoundValue;
use DX::Class;

with 'DX::Role::SimpleAction';

has new_value => (is => 'ro', required => 1, isa => Value);

sub for_deparse {
  my ($self) = @_;
  [ statement => [
    [ symbol => 'BindValue' ],
    [ value_path => $self->target_path ],
    [ value_path => $self->new_value
                         ->action_builder
                         ->inner_action_builder
                         ->target_path ],
  ] ];
}

sub _build__updates {
  my ($self) = @_;
  [
    DX::Update::SetValue->new(
      target_path => $self->target_path,
      new_value => $self->new_value,
    )
  ]
}

1;

